"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pluginToken = void 0;
const axios_1 = __importDefault(require("axios"));
function isTokenRenewed(newToken, error) {
    var _a;
    if (!(newToken && ((_a = error.config) === null || _a === void 0 ? void 0 : _a.headers)))
        return false;
    const oldCredentials = error.config.headers["Authorization"];
    return !oldCredentials.includes(newToken);
}
function pluginToken(provider) {
    return {
        request: (_, config) => __awaiter(this, void 0, void 0, function* () {
            const token = yield provider.getToken();
            if (token) {
                return Object.assign(Object.assign({}, config), { headers: Object.assign(Object.assign({}, config.headers), { Authorization: `Bearer ${token}` }) });
            }
            return config;
        }),
        error: provider.renewToken
            ? (_, __, error) => __awaiter(this, void 0, void 0, function* () {
                var _a;
                if (axios_1.default.isAxiosError(error) &&
                    provider.renewToken &&
                    error.config) {
                    if (((_a = error.response) === null || _a === void 0 ? void 0 : _a.status) === 401) {
                        const newToken = yield provider.renewToken();
                        if (isTokenRenewed(newToken, error)) {
                            const retryConfig = Object.assign({}, error.config);
                            // @ts-ignore
                            retryConfig.headers = Object.assign(Object.assign({}, retryConfig.headers), { Authorization: `Bearer ${newToken}` });
                            // retry with new token and without interceptors
                            return (0, axios_1.default)(retryConfig);
                        }
                    }
                }
                throw error;
            })
            : undefined,
    };
}
exports.pluginToken = pluginToken;
